routes/web.php
<?php

use App\Http\Controllers\Admin\CommentController;
use App\Http\Controllers\Admin\PhotoController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\CommentsController;
use App\Http\Controllers\LanguageSwitcherController;
use App\Http\Controllers\PhotosController;
use App\Http\Controllers\UsersController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



Route::middleware('language')->group(function (){


    Route::prefix('admin')->middleware('auth')->name('admin.')->group(function () {
        Route::resources([
            'users' => UserController::class,
            'photos' => PhotoController::class,
            'comments' => CommentController::class,
        ]);
    });

    Route::get('/', [PhotosController::class, 'index'])->name('main');
    Auth::routes();
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('photos', PhotosController::class)->except(['edit', 'update']);
    Route::resource('users', UsersController::class)->except(['create', 'store', 'destroy']);
    Route::resource('comments', CommentsController::class)->only('store');
});


Route::get('language/{locale}', [LanguageSwitcherController::class, 'switcher'])->name('language.switcher')->where('locale', 'en|ru');

app/Models/Photo.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @method static paginate(int $int)
 */
class Photo extends Model
{
    use HasFactory;

    protected $fillable = ['title', 'picture', 'user_id'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class)->latest();
    }
}

app/Http/Controllers/Admin/PhotoController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\PhotoRequest;
use App\Models\Photo;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PhotoController extends Controller
{

    /**
     * @return Application|Factory|View
     */
    public function index()
    {
        $photos = Photo::all();
        return view('admin.photos.index', compact('photos'));
    }


    /**
     * @return Application|Factory|View
     */
    public function create()
    {
        $users = User::all();
        return view('admin.photos.create', compact('users'));
    }


    /**
     * @param PhotoRequest $request
     * @return RedirectResponse
     */
    public function store(PhotoRequest $request): RedirectResponse
    {
        $photo = new Photo($request->all());
        if ($request->hasFile('picture')){
            $photo->picture = $request->file('picture')->store('pictures', 'public');
        }
        $photo->save();
        return redirect()->route('admin.photos.index')->with('success', "photo success created");
    }


    /**
     * @param Photo $photo
     * @return Application|Factory|View
     */
    public function show(Photo $photo)
    {

        return view('admin.photos.show', compact('photo'));
    }



    /**
     * @param Photo $photo
     * @return Application|Factory|View
     */
    public function edit(Photo $photo)
    {
        $users = User::all();
        return view('admin.photos.edit', compact('photo', 'users'));
    }


    /**
     * @param PhotoRequest $request
     * @param Photo $photo
     * @return RedirectResponse
     */
    public function update(PhotoRequest $request, Photo $photo): RedirectResponse
    {
        $data = $request->all();
        if ($request->hasFile('picture')) {
            $file = $request->file('picture');
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $photo->update($data);
        return redirect()->route('admin.photos.index')->with('success', "photo success updated");
    }


    /**
     * @param Photo $photo
     * @return RedirectResponse
     */
    public function destroy(Photo $photo): RedirectResponse
    {
        $photo->delete();
        return redirect()->route('admin.photos.index')->with('success', "photo success deleted");
    }
}

app/Http/Controllers/PhotosController.php
<?php

namespace App\Http\Controllers;

use App\Models\Photo;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PhotosController extends Controller
{

    public function __construct()
    {
        return $this->middleware('auth')->except(['index', 'show']);
    }

    /**
     * @return Application|Factory|View
     */
    public function index()
    {
        $photos = Photo::latest()->paginate(6);
        return view('photos.index', compact('photos'));
    }


    /**
     * @return Application|Factory|View
     */
    public function create()
    {
        return view('photos.create');
    }


    /**
     * @param Request $request
     * @return RedirectResponse
     */
    public function store(Request $request): RedirectResponse
    {
        $request->validate([
            'title' => ['bail', 'required', 'min:2'],
            'picture' => ['bail', 'required', 'mimes:jpg,png'],
        ]);
        $photo = new Photo();
        $photo->title = $request->input('title');
        if ($request->hasFile('picture')){
            $photo->picture = $request->file('picture')->store('pictures', 'public');
        }
        $photo->user_id = Auth::user()->getAuthIdentifier();
        $photo->save();

        return redirect()->route('photos.index')->with('success', 'photo successfully created');
    }


    /**
     * @param Photo $photo
     * @return Application|Factory|View
     */
    public function show(Photo $photo)
    {
        $total = 0;
        $count = 0;
        $score = 0;
        foreach ($photo->comments as $comment){
            $count++;
            $total += $comment->grade;
        }
        if ($total != 0 and $count != 0){
            $score = $total/$count;
        }

        return view('photos.show', compact('photo', 'score'));
    }


    /**
     * @param Photo $photo
     * @return RedirectResponse
     */
    public function destroy(Photo $photo): RedirectResponse
    {
        $this->authorize('delete', $photo);
        $photo->delete();
        return back()->with('success', 'photo successfully deleted');
    }
}

resources/views/admin/photos/create.blade.php
@extends('layouts.app')

@section('content')
    @error('picture')
    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
    @enderror
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">@lang('messages.create')</div>
                    <div class="card-body">
                        <form action="{{route('admin.photos.store')}}" method="POST"
                              enctype="multipart/form-data">
                            @csrf
                            <div class="form-group row">
                                <label for="title" class="col-md-4 col-form-label text-md-right">@lang('messages.title')</label>
                                <div class="col-md-6">
                                    <input class="form-control @error('title') is-invalid @enderror" type="text"
                                           id="title" name="title"
                                           value="{{ old('title') }}"/>
                                    @error('title')
                                    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                                    @enderror
                                </div>
                            </div>
                            <br>

                            <div class="form-group row">
                                <label for="picture"
                                       class="col-md-4 col-form-label text-md-right">@lang('messages.photo')</label>

                                <div class="col-md-6">
                                    <input name="picture" type="file" class="custom-file-input @error('picture') is-invalid @enderror" id="picture" aria-describedby="picture">
                                    @error('picture')
                                    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                                    @enderror
                                </div>
                            </div>
                            <br>

                            <div class="form-group row">
                                <label for="user_id" class="col-md-4 col-form-label text-md-right">@lang('messages.users')</label>
                                <div class="col-md-6">
                                    <select class="custom-select" name="user_id">
                                        @foreach($users as $user)
                                            <option value="{{$user->id}}">{{$user->name}}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <br>

                            <div class="form-group text-center">
                                <button type="submit" class="btn btn-outline-success">@lang('messages.create')</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

@endsection

resources/views/admin/photos/edit.blade.php
@extends('layouts.app')

@section('content')
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">@lang('messages.edit')</div>
                    <div class="card-body">
                        <form action="{{route('admin.photos.update', ['photo' => $photo])}}" method="POST"
                              enctype="multipart/form-data">
                            @csrf
                            @method('PUT')
                            <div class="form-group row">
                                <label for="title" class="col-md-4 col-form-label text-md-right">@lang('messages.title')</label>

                                <div class="col-md-6">
                                    <input class="form-control @error('title') is-invalid @enderror" type="text"
                                           id="title" name="title"
                                           value="{{ $photo->title }}"/>
                                    @error('title')
                                    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                                    @enderror
                                </div>
                            </div>
                            <br>

                            <div class="form-group row">
                                <label for="picture"
                                       class="col-md-4 col-form-label text-md-right">@lang('messages.photo')</label>

                                <div class="col-md-6">
                                    <input name="picture" type="file" class="custom-file-input @error('picture') is-invalid @enderror" id="picture" aria-describedby="picture">
                                    @error('picture')
                                    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group row">
                                <label for="user_id" class="col-md-4 col-form-label text-md-right">@lang('messages.users')</label>
                                <div class="col-md-6">
                                    <select class="custom-select" name="user_id">
                                        @foreach($users as $user)
                                            <option value="{{$user->id}}">{{$user->name}}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>

                            <div class="form-group text-center">
                                <button type="submit" class="btn btn-outline-success">Update</button>
                            </div>

                        </form>
                    </div>
                </div>
            </div>
        </div>
@endsection

resources/views/admin/photos/index.blade.php
@extends('layouts.app')

@section('content')
    @include('navbar.navbar')
    <a class="btn btn-outline-success" href="{{route('admin.photos.create')}}">@lang('messages.create')</a>
        <table class="table">
            <thead class="thead-dark">
            <tr>
                <th scope="col">№</th>
                <th scope="col">@lang('messages.photo')</th>
                <th scope="col">@lang('messages.title')</th>
                <th scope="col">@lang('messages.author')</th>
                <th scope="col">@lang('messages.actions')</th>
            </tr>
            </thead>
            <tbody>
            @foreach($photos as $photo)
                <tr>
                    <th scope="row">{{$loop->iteration}}</th>
                    <td>
                        <img height="150" width="150" src="{{asset('/storage/' . $photo->picture)}}" alt="{{$photo->picture}}">
                    </td>
                    <td><a href="{{route('admin.photos.show', compact('photo'))}}">
                            {{$photo->title}}
                        </a></td>
                    <td>{{$photo->user->name}}</td>
                    <td class="d-flex">
                        <a class="btn btn-sm btn-outline-success mr-2" href="{{route('admin.photos.edit', ['photo' => $photo])}}">@lang('messages.edit')</a>
                        <form
                            action="{{route('admin.photos.destroy' , ['photo' => $photo])}}"
                            method="post">
                            @csrf
                            @method('delete')
                            <button class="btn btn-sm btn-outline-danger">
                                @lang('messages.delete')
                            </button>
                        </form>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
@endsection